/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      PLCmodule C14

  Description:  include file for eepromio driver

  -------------------------------------------------------------------------

                $RCSfile: EepromIo.h,v $
                
                $Author: A.Suess $
                
                $Revision: 1.1.1.1 $  $Date: 2004/09/16 11:56:03 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2003/10/28 -ct:   start of the implementation version 1.00

****************************************************************************/

#ifndef _EEPROMIO_H_
#define _EEPROMIO_H_




//---------------------------------------------------------------------------
// const defines
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// types
//---------------------------------------------------------------------------

typedef struct
{
    BYTE   m_bType;                     // EEPROM type
    BYTE   m_bAmount;                   // count of mountede EEPROM's -> 0 = 1 EEPROM
                                        //                               1 = 2 EEPROM
    BYTE   m_bPageSize;                 // page size of the eeprom
    BYTE   m_bBaudRate;                 // baudrate of the eeprom
    DWORD  m_dwEndAdr;                  // endaddress of the eeprom

} tEprm;



//---------------------------------------------------------------------------
// function prototypes
//---------------------------------------------------------------------------

// init of the bus interface
void EepromInit (BYTE bBaudrate_p);
// write one block into the eeprom
BYTE EepromWrBlk (BYTE FAR* pbSrcPtr_p, DWORD dwDstAdr_p, DWORD dwSize_p, tEprm FAR* pEprom_p);
// read one block out of the eeprom
BYTE EepromRdBlk (BYTE FAR* pbDstPtr_p, DWORD dwSrcAdr_p, DWORD dwSize_p, tEprm FAR* pEprom_p);
// get the used baudrate
BYTE EEPGetBaudrate (BYTE bDeviceType_p);
// get the eeprom size
DWORD EEPGetSize (BYTE bDeviceType_p);
// get the eeprom page size
BYTE EEPGetPageSize (BYTE bDeviceType_p);
// get the eeprom end address
DWORD EEPGetEndAdr (BYTE bDeviceType_p);


#endif  // #ifndef _EEPROMIO_H_
