/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      PLCmodule C14

  Description:  include file for SSC0 unit of the XC161 controller

  -------------------------------------------------------------------------

                $RCSfile: SpiDrv.h,v $
                
                $Author: A.Suess $
                
                $Revision: 1.1.1.1 $  $Date: 2004/09/16 11:56:03 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2003/10/28 -ct:   start of the implementation version 1.00

****************************************************************************/

#ifndef _SPIDRV_H_
#define _SPIDRV_H_

//---------------------------------------------------------------------------
// const defines
//---------------------------------------------------------------------------

// version of the driver
#define DOMAIN_SPI      0x01
#define REVISION_SPI    0x00

// const of the baudrate values
#define BR2M            0x0009
#define BR1M            0x0013
#define BR100k          0x00C7

// SPI eeprom command 
#define CMD_WRSR  0x1                 // Write status register
#define CMD_WRITE 0x2                 // Write data to memeory array beginning at 
                                      // selected adress
#define CMD_READ  0x3                 // Read data from memeory array beginning at
                                      // selected adress
#define CMD_WRDI  0x4                 // Reset the write enable latch 
                                      // (disable write operations)
#define CMD_RDSR  0x5                 // Read status register
#define CMD_WREN  0x6                 // Set the write enable latch
                                      // (enable write operations)
#define CMD_DUMMY 0xFF                // DUMMY byte

#define WIPBIT    0x0                 // Statuswert vom WIP-Bit

//---------------------------------------------------------------------------
// types
//---------------------------------------------------------------------------
#ifndef _tWORD

#define _tWORD

    typedef union
    {
      WORD w;
      struct
        {
        BYTE low;
        BYTE high;
        } b;
    
    }tWORD;

#endif    

//---------------------------------------------------------------------------
// function prototypes
//---------------------------------------------------------------------------

extern WORD SpiInit         (WORD wBaudrate_p);
extern void SpiReadPage     (BYTE FAR* pbDstPtr_p, DWORD dwSrcAdr_p, 
                             DWORD dwSize_p, BYTE bEpromNr_p);
extern void SpiWritePage    (BYTE FAR* pbSrcPtr_p, DWORD dwDstAdr_p,
                             DWORD dwSize_p, BYTE bEpromNr_p);


#endif  // #ifndef _SPIDRV_H_
