/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      PLCmodule C14

  Description:  include file for memory driver serial eeprom

  -------------------------------------------------------------------------

                $RCSfile: MdvSeDrv.h,v $
                
                $Author: A.Suess $
                
                $Revision: 1.1 $  $Date: 2004/10/06 11:25:05 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2003/10/28 -ct:   start of the implementation version 1.00

****************************************************************************/

#ifndef _MDVSEDRV_H_
#define _MDVSEDRV_H_




//---------------------------------------------------------------------------
// const defines
//---------------------------------------------------------------------------

// definition to select device
#define EPRM25080   0x01                //  1 kByte
#define EPRM25160   0x02                //  2 kByte
#define EPRM25170   0x03                //  2 kByte
#define EPRM25640   0x04                //  8 kByte
#define EPRM25650   0x05                //  8 kByte
#define EPRM25128   0x06                // 16 kByte
#define EPRM25256   0x07                // 32 kByte
#define EPRM25512   0x08                // 64 kByte

// const of the baudrate values
#define BR2M            0x0009
#define BR1M            0x0013
#define BR100k          0x00C7


#define MDV_SUCCESSFUL          0x00
#define MDV_UNVALID_DEVICE_TYPE 0xFF

#define MDV_UNVALID_ACCESS      -1L


//---------------------------------------------------------------------------
// types
//---------------------------------------------------------------------------

typedef struct
{
    // input parameter
    BYTE   m_bType;                     // EEPROM type
    BYTE   m_bDeviceID;                 // device number
    BYTE   m_bBaudRate;                 // baudrate of the eeprom

    // output parameter
    BYTE   m_bPageSize;                 // page size of the eeprom
    DWORD  m_dwEndAdr;                  // endaddress of the eeprom

} tMdvSeCfg;


//---------------------------------------------------------------------------
// function prototypes
//---------------------------------------------------------------------------

// init of the bus interface
BYTE  PUBLIC MdvSeInit (tMdvSeCfg *pDevCfg_p);
// write one block into the eeprom
DWORD PUBLIC MdvSeWriteData (BYTE GENERIC* pbSrcPtr_p, DWORD dwDstAdr_p, DWORD dwSize_p);
// read one block out of the eeprom
DWORD PUBLIC MdvSeReadData (BYTE GENERIC* pbDstPtr_p, DWORD dwSrcAdr_p, DWORD dwSize_p);

#endif  // #ifndef _MDVSEDRV_H_
