/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      PLCmodule C14

  Description:  The module contents interface to power fail process.

  -------------------------------------------------------------------------

                $RCSfile: PwrfDrv.h,v $
                
                $Author: A.Suess $
                
                $Revision: 1.4 $  $Date: 2005/01/26 12:20:34 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2003/02/12 -as:   Start der Implementierung

****************************************************************************/

#ifndef _PWRFDRV_H_
#define _PWRFDRV_H_

//--------------------------------------------------------------------------

// -------------------------------------------------------------------------
// const defines

// -------------------------------------------------------------------------
// types

typedef void (PUBLIC ROM* tfpPwrFailCbHandler) (bit bitPowerFailState);

// -------------------------------------------------------------------------
// function prototypes

void  PUBLIC PowerFailInit                 (void);
void  PUBLIC PowerFailShutDown             (void);
void  PUBLIC PowerFailInstallHandler       (tfpPwrFailCbHandler fpPowerFailHandler_p);
BYTE  PUBLIC PowerFailGetPowerFailState    (void);
void  PUBLIC PowerFailStartCriticalSection (void);
void  PUBLIC PowerFailEndCriticalSection   (void);
void  PUBLIC PowerFailEnableObservance     (void);
void  PUBLIC PowerFailDisableObservance    (void);

//--------------------------------------------------------------------------


#endif  // #ifndef _PWRFDRV_H_

