// example for SIO-driver

// with ASC0 the monitor is connected to the modul 
// Connect a second cable from PC to ASC2 interface and
// configure the terminal programm (e.g. HyperTerminal) to
// 57600bd, 8data, 1stop, no parity and hardware-handshake 

#include <xc161.h>

#include "generic/global.h"
#include "../include/SioDrv.h"

//#define INSTANCE_NUM    0
#define INSTANCE_NUM    2

tSerialInst FAR*  pSerialInst;

void  main (void)
{

tSioCfgParam      SioCfgParam;
BYTE  bTxData;
BYTE  bRxData;
BOOL  fRes;


    // initialze the instance data structures
    SioInitInstData();


    // get instance pointer of serial port
    pSerialInst = SioGetInstData (INSTANCE_NUM);

    if (pSerialInst != NULL)
    {
        // init UART 
        SioCfgParam.m_dwBaudrate = 57600;
        SioCfgParam.m_bDataBits  = 8;
        SioCfgParam.m_bParity    = 0;
        SioCfgParam.m_bStopBits  = 1;
        SioCfgParam.m_bProtocol  = 2;

        pSerialInst->m_pfnSerialInit(&SioCfgParam);

        PSW_IEN = 1;


        for (bTxData='A'; bTxData<='Z'; bTxData++)
        {
            fRes = pSerialInst->m_pfnPutByte(bTxData);
            if ( !fRes )
            {
                TRACE0("\nsend error\n");
            }
        }


        bRxData = 0;
        do
        {
            fRes = pSerialInst->m_pfnGetByte(&bRxData);
            if ( fRes )
            {
                bTxData = bRxData;
                pSerialInst->m_pfnPutByte(bTxData);
                TRACE2("\nTxData='%c' / 0x%02X", bTxData, (WORD)bTxData);
            }
        }
        while (bRxData != 0x1A);        // warten auf ^Z


        // switch off UART
        pSerialInst->m_pfnSerialClose();
    }

    TRACE0("\n\n*** End of Program ***\n\n");
    for(;;);

}


//---------------------------------------------------------------------------
//
// Function:     putchar
//
// Description:  This function sends a char to standard device. 
//
// Parameters:   character
// 
// Returns:      none
//               
//
// State:        
//
//---------------------------------------------------------------------------

signed char putchar (signed char cZeichen)  
{
DWORD dwBufSize;

    if (cZeichen == '\n')
    {
           // put char in send buffer ...
           pSerialInst->m_pfnPutByte('\r');
           // wait until the interface has take it (jamming).
           do
           {
              pSerialInst->m_pfnTxFifoDataSize(&dwBufSize);

           } while (dwBufSize);
    }

    // put char in send buffer ...
    pSerialInst->m_pfnPutByte(cZeichen);
    // uwait until the interface has take it (jamming).
    do
    {
       pSerialInst->m_pfnTxFifoDataSize(&dwBufSize);

    } while (dwBufSize);

    return (cZeichen);
}


