/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      PLCmodule C14

  Description:  interface for command interpreter

  -------------------------------------------------------------------------

                $RCSfile: CmdInt.h,v $
                
                $Author: A.Suess $
                
                $Revision: 1.1.1.1 $  $Date: 2004/09/16 11:56:05 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2003/02/12 -as:   Start der Implementierung

****************************************************************************/

#ifndef _CMDINT_H_
#define _CMDINT_H_

//---------------------------------------------------------------------------
// const defines
//---------------------------------------------------------------------------

// -------------------------------------------------------------------------
// Dieses Makro wird bentigt um Eintrge in der Kommandotabelle zu init.
// Dadurch wird das Kommando selbst als auch die Kommandolnge ohne '/0'
// abgelegt.
#define COMMAND(A) (A), (sizeof(A)-1)

// -------------------------------------------------------------------------
// Dieses Makro berechnet die Gre einer Tabelle/Feldes. Es ist die Adresse 
// auf den Anfang der Tabelle zu bergeben. Bei mehrdimensionalen Feldern
// ist die Adresse auf den Anfang eines Vektors zu bergeben. 
#define tab_entries(a)   (sizeof(a)/sizeof(*(a)))


//---------------------------------------------------------------------------
// types
//---------------------------------------------------------------------------

typedef void (PUBLIC ROM* tfpCmdInit)    (void);
typedef void (PUBLIC ROM* tfpCmdProcess) (char ** pArgList_p);

typedef struct
{
    BYTE*           m_pstrCommand;
    WORD            m_wCmdSize;
    BYTE*           m_pstrCommandDescription;
    tfpCmdInit      m_fpCmdInit;
    tfpCmdProcess   m_fpCmdProcess;
    
} tCmdTableEntry;


//---------------------------------------------------------------------------
// function prototypes
//---------------------------------------------------------------------------

void    PUBLIC CmdIntInit     (tCmdTableEntry* pCmdTable_p, WORD wCmdEntries_p);
void    PUBLIC CmdIntProcess  (void);
void    PUBLIC CmdInitCommand (void);
void    PUBLIC CmdPrintHelp   (void);
void    PUBLIC CmdIntPrintStr (BYTE FAR * pbString_p);

#endif  // #ifndef _CMDINT_H_

